unit UfrmMasterDetail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TeEngine, TeeProcs, Chart, ExtCtrls, DBCtrls, Grids,
  DBGrids, DB, ADODB;

type
  TfrmMasterDetail = class(TForm)
    ADOConnect: TADOConnection;
    adstMaster: TADODataSet;
    adstDetail: TADODataSet;
    dsMaster: TDataSource;
    dsDetail: TDataSource;
    grMaster: TDBGrid;
    grDetail: TDBGrid;
    navMaster: TDBNavigator;
    navDetail: TDBNavigator;
    tcCurve: TChart;
    lblMasterTable: TLabel;
    lblDetailTable: TLabel;
    btnCreate: TButton;
    SaveDlg: TSaveDialog;
    OpenDlg: TOpenDialog;
    btnOpen: TButton;
    Bevel1: TBevel;
    procedure btnCreateClick(Sender: TObject);
    procedure dsMasterDataChange(Sender: TObject; Field: TField);
    procedure btnOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure ShowCurve;
    procedure AddCurves;
  public
    { Public declarations }
  end;

var
  frmMasterDetail: TfrmMasterDetail;

implementation

{$R *.dfm}

uses
  Series, ComObj, ActiveX;

resourcestring
  rsConnStrFmt = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s';

  rsCreateMasterTable = 'CREATE TABLE tbMaster (' + #13#10 +
    'MainID COUNTER CONSTRAINT PrimaryKey PRIMARY KEY,' + #13#10 +
    '[Name] TEXT(31)' + #13#10 +
    ')';

  rsCreateDetailTable = 'CREATE TABLE tbDetail (' + #13#10 +
    'DetailID COUNTER CONSTRAINT PrimaryKey PRIMARY KEY,' + #13#10 +
    'MainID INTEGER,' + #13#10 +
    'X FLOAT,' + #13#10 +
    'Y FLOAT' + #13#10 +
    ')';

  rsCreateConstraint = 'ALTER TABLE tbDetail ADD CONSTRAINT MasterDetail ' +
    'FOREIGN KEY (MainID) REFERENCES tbMaster ON UPDATE CASCADE ON DELETE CASCADE';
  
function GetConnStr(AFileName: String): String;
begin
  Result:= Format(rsConnStrFmt, [AFileName]);
end;

function CreateAccessDatabase(AFileName: String): String;
var
  Catalog: OleVariant;
begin
  Result:= '';
  try
    Catalog:= CreateOleObject('ADOX.Catalog');
    Catalog.Create(Format(rsConnStrFmt, [AFileName]));
    VariantClear(Catalog);
  except
    on E: Exception do
      Result:= E.Message;
  end;
end;

procedure TfrmMasterDetail.AddCurves;
const
  SinTable: array[0..64] of Integer = (127, 152, 176, 198, 217, 233, 244, 252, 
    254, 252, 244, 233, 217, 198, 176, 152, 127, 102, 78, 56, 37, 21, 10, 2, 0, 
    2, 10, 21, 37, 56, 78, 102, 127, 152, 176, 198, 217, 233, 244, 252, 254, 
    252, 244, 233, 217, 198, 176, 152, 127, 102, 78, 56, 37, 21, 10, 2, 0, 2, 
    10, 21, 37, 56, 78, 102, 127);
 RectTable: array[0..63] of Integer = (0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
   1, 1, 1, 1, 1, 1, 1, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
   -1, -1, -1, -1, -1, -1, -1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
   1, 1, 1, 1, 1, 0);
 TriaTable: array[0..40] of Integer = (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 9, 8, 
   7, 6, 5, 4, 3, 2, 1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 9, 8, 7, 6, 5, 4, 3, 
   2, 1, 0);
 SawTable: array[0..33] of Integer = (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 0, 1, 2, 
   3, 4, 5, 6, 7, 8, 9, 10, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 0);
var
  i: Integer;
begin
  // 
  adstMaster.Insert;
  adstMaster.FieldByName('Name').AsString:= '';
  adstMaster.Post;
  for i:= Low(SinTable) to High(SinTable) do
  begin
    adstDetail.Insert;
    adstDetail.FieldByName('X').AsFloat:= i;
    adstDetail.FieldByName('Y').AsFloat:= SinTable[i];
    adstDetail.Post;
  end;
  // 
  adstMaster.Insert;
  adstMaster.FieldByName('Name').AsString:= '';
  adstMaster.Post;
  for i:= Low(RectTable) to High(RectTable) do
  begin
    adstDetail.Insert;
    adstDetail.FieldByName('X').AsFloat:= i;
    adstDetail.FieldByName('Y').AsFloat:= RectTable[i];
    adstDetail.Post;
  end;
  // 
  adstMaster.Insert;
  adstMaster.FieldByName('Name').AsString:= '';
  adstMaster.Post;
  for i:= Low(TriaTable) to High(TriaTable) do
  begin
    adstDetail.Insert;
    adstDetail.FieldByName('X').AsFloat:= i;
    adstDetail.FieldByName('Y').AsFloat:= TriaTable[i];
    adstDetail.Post;
  end;
  // 
  adstMaster.Insert;
  adstMaster.FieldByName('Name').AsString:= '';
  adstMaster.Post;
  for i:= Low(SawTable) to High(SawTable) do
  begin
    adstDetail.Insert;
    adstDetail.FieldByName('X').AsFloat:= i;
    adstDetail.FieldByName('Y').AsFloat:= SawTable[i];
    adstDetail.Post;
  end;
end;

procedure TfrmMasterDetail.btnCreateClick(Sender: TObject);
begin
  SaveDlg.InitialDir:= ExtractFilePath(Application.ExeName);
  if not SaveDlg.Execute then Exit;
  //    -   
  if FileExists(SaveDlg.FileName) then
    DeleteFile(SaveDlg.FileName);

  ADOConnect.Close;
  //   
  CreateAccessDatabase(SaveDlg.FileName);
  //  
  ADOConnect.ConnectionString:= GetConnStr(SaveDlg.FileName);
  ADOConnect.Execute(rsCreateMasterTable, cmdText);
  ADOConnect.Execute(rsCreateDetailTable, cmdText);
  ADOConnect.Execute(rsCreateConstraint, cmdText);
  //  
  ADOConnect.Open;
  adstMaster.Open;
  adstDetail.Open;
  //  
  adstDetail.DisableControls;
  adstMaster.DisableControls;
  try
    AddCurves;
  finally
    adstDetail.EnableControls;
    adstMaster.EnableControls;
  end;
  Caption:= Format('%s - %s', [Application.Title, SaveDlg.FileName]);
end;

procedure TfrmMasterDetail.ShowCurve;
var
  LineSeries: TLineSeries;
begin
  tcCurve.RemoveAllSeries;
  LineSeries:= TLineSeries.Create(tcCurve);
  with LineSeries do
  begin
    ParentChart:= tcCurve;
    Color:= clBlue;
    LinePen.Width:= 2;
  end;

  with adstDetail do
  begin
    DisableControls;
    try
      First;
      while not Eof do
      begin
        LineSeries.AddXY(FieldByName('X').AsFloat, FieldByName('Y').AsFloat);
        Next;
      end;
      First;
    finally
      EnableControls;
    end;
  end;

  tcCurve.AddSeries(LineSeries);
  tcCurve.Title.Text.Text:= adstMaster.FieldByName('Name').AsString;
  tcCurve.UndoZoom;
end;

procedure TfrmMasterDetail.btnOpenClick(Sender: TObject);
begin
  OpenDlg.InitialDir:= ExtractFilePath(Application.ExeName);
  if not OpenDlg.Execute then Exit;

  ADOConnect.Close;
  ADOConnect.ConnectionString:= GetConnStr(OpenDlg.FileName);
  ADOConnect.Open;
  adstMaster.Open;
  adstDetail.Open;
  adstMaster.Refresh;

  Caption:= Format('%s - %s', [Application.Title, OpenDlg.FileName]);
end;

procedure TfrmMasterDetail.dsMasterDataChange(Sender: TObject; Field: TField);
begin
  if not adstDetail.Active then Exit;
  ShowCurve;
end;

procedure TfrmMasterDetail.FormCreate(Sender: TObject);
begin
  Caption:= Application.Title;
end;

procedure TfrmMasterDetail.FormDestroy(Sender: TObject);
begin
  ADOConnect.Close;
end;

end.
